
<!doctype html>
<html lang="en" class="no-js">
  <head>
    
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width,initial-scale=1">
      
      
      
        <link rel="canonical" href="https://autovtools.gitlab.io/autovrtfm/usage/collaboration/hedgedoc/">
      
      
        <link rel="prev" href="../vnc/">
      
      
        <link rel="next" href="../msfdb/">
      
      
      <link rel="icon" href="../../../assets/images/favicon.png">
      <meta name="generator" content="mkdocs-1.5.3, mkdocs-material-9.4.6">
    
    
      
        <title>Shared Notes - autovnet</title>
      
    
    
      <link rel="stylesheet" href="../../../assets/stylesheets/main.35e1ed30.min.css">
      
        
        <link rel="stylesheet" href="../../../assets/stylesheets/palette.356b1318.min.css">
      
      


    
    
      
    
    
      
        
        
        <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
        <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:300,300i,400,400i,700,700i%7CRoboto+Mono:400,400i,700,700i&display=fallback">
        <style>:root{--md-text-font:"Roboto";--md-code-font:"Roboto Mono"}</style>
      
    
    
      <link rel="stylesheet" href="../../../stylesheets/extra.css">
    
    <script>__md_scope=new URL("../../..",location),__md_hash=e=>[...e].reduce((e,_)=>(e<<5)-e+_.charCodeAt(0),0),__md_get=(e,_=localStorage,t=__md_scope)=>JSON.parse(_.getItem(t.pathname+"."+e)),__md_set=(e,_,t=localStorage,a=__md_scope)=>{try{t.setItem(a.pathname+"."+e,JSON.stringify(_))}catch(e){}}</script>
    
      

    
    
    
  </head>
  
  
    
    
      
    
    
    
    
    <body dir="ltr" data-md-color-scheme="slate" data-md-color-primary="indigo" data-md-color-accent="indigo">
  
    
    
      <script>var palette=__md_get("__palette");if(palette&&"object"==typeof palette.color)for(var key of Object.keys(palette.color))document.body.setAttribute("data-md-color-"+key,palette.color[key])</script>
    
    <input class="md-toggle" data-md-toggle="drawer" type="checkbox" id="__drawer" autocomplete="off">
    <input class="md-toggle" data-md-toggle="search" type="checkbox" id="__search" autocomplete="off">
    <label class="md-overlay" for="__drawer"></label>
    <div data-md-component="skip">
      
        
        <a href="#shared-notes" class="md-skip">
          Skip to content
        </a>
      
    </div>
    <div data-md-component="announce">
      
    </div>
    
    
      

  

<header class="md-header md-header--shadow md-header--lifted" data-md-component="header">
  <nav class="md-header__inner md-grid" aria-label="Header">
    <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="autovnet" class="md-header__button md-logo" aria-label="autovnet" data-md-component="logo">
      
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M12 8a3 3 0 0 0 3-3 3 3 0 0 0-3-3 3 3 0 0 0-3 3 3 3 0 0 0 3 3m0 3.54C9.64 9.35 6.5 8 3 8v11c3.5 0 6.64 1.35 9 3.54 2.36-2.19 5.5-3.54 9-3.54V8c-3.5 0-6.64 1.35-9 3.54Z"/></svg>

    </a>
    <label class="md-header__button md-icon" for="__drawer">
      
      <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M3 6h18v2H3V6m0 5h18v2H3v-2m0 5h18v2H3v-2Z"/></svg>
    </label>
    <div class="md-header__title" data-md-component="header-title">
      <div class="md-header__ellipsis">
        <div class="md-header__topic">
          <span class="md-ellipsis">
            autovnet
          </span>
        </div>
        <div class="md-header__topic" data-md-component="header-topic">
          <span class="md-ellipsis">
            
              Shared Notes
            
          </span>
        </div>
      </div>
    </div>
    
      
        <form class="md-header__option" data-md-component="palette">
  
    
    
    
    <input class="md-option" data-md-color-media="" data-md-color-scheme="slate" data-md-color-primary="indigo" data-md-color-accent="indigo"  aria-label="Switch to light mode"  type="radio" name="__palette" id="__palette_1">
    
      <label class="md-header__button md-icon" title="Switch to light mode" for="__palette_2" hidden>
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M17 7H7a5 5 0 0 0-5 5 5 5 0 0 0 5 5h10a5 5 0 0 0 5-5 5 5 0 0 0-5-5m0 8a3 3 0 0 1-3-3 3 3 0 0 1 3-3 3 3 0 0 1 3 3 3 3 0 0 1-3 3Z"/></svg>
      </label>
    
  
    
    
    
    <input class="md-option" data-md-color-media="" data-md-color-scheme="default" data-md-color-primary="indigo" data-md-color-accent="indigo"  aria-label="Switch to dark mode"  type="radio" name="__palette" id="__palette_2">
    
      <label class="md-header__button md-icon" title="Switch to dark mode" for="__palette_1" hidden>
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M17 6H7c-3.31 0-6 2.69-6 6s2.69 6 6 6h10c3.31 0 6-2.69 6-6s-2.69-6-6-6zm0 10H7c-2.21 0-4-1.79-4-4s1.79-4 4-4h10c2.21 0 4 1.79 4 4s-1.79 4-4 4zM7 9c-1.66 0-3 1.34-3 3s1.34 3 3 3 3-1.34 3-3-1.34-3-3-3z"/></svg>
      </label>
    
  
</form>
      
    
    
    
      <label class="md-header__button md-icon" for="__search">
        
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
      </label>
      <div class="md-search" data-md-component="search" role="dialog">
  <label class="md-search__overlay" for="__search"></label>
  <div class="md-search__inner" role="search">
    <form class="md-search__form" name="search">
      <input type="text" class="md-search__input" name="query" aria-label="Search" placeholder="Search" autocapitalize="off" autocorrect="off" autocomplete="off" spellcheck="false" data-md-component="search-query" required>
      <label class="md-search__icon md-icon" for="__search">
        
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
        
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12Z"/></svg>
      </label>
      <nav class="md-search__options" aria-label="Search">
        
        <button type="reset" class="md-search__icon md-icon" title="Clear" aria-label="Clear" tabindex="-1">
          
          <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M19 6.41 17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12 19 6.41Z"/></svg>
        </button>
      </nav>
      
        <div class="md-search__suggest" data-md-component="search-suggest"></div>
      
    </form>
    <div class="md-search__output">
      <div class="md-search__scrollwrap" data-md-scrollfix>
        <div class="md-search-result" data-md-component="search-result">
          <div class="md-search-result__meta">
            Initializing search
          </div>
          <ol class="md-search-result__list" role="presentation"></ol>
        </div>
      </div>
    </div>
  </div>
</div>
    
    
      <div class="md-header__source">
        <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="Go to repository" class="md-source" data-md-component="source">
  <div class="md-source__icon md-icon">
    
    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Free 6.4.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) Copyright 2023 Fonticons, Inc.--><path d="M439.55 236.05 244 40.45a28.87 28.87 0 0 0-40.81 0l-40.66 40.63 51.52 51.52c27.06-9.14 52.68 16.77 43.39 43.68l49.66 49.66c34.23-11.8 61.18 31 35.47 56.69-26.49 26.49-70.21-2.87-56-37.34L240.22 199v121.85c25.3 12.54 22.26 41.85 9.08 55a34.34 34.34 0 0 1-48.55 0c-17.57-17.6-11.07-46.91 11.25-56v-123c-20.8-8.51-24.6-30.74-18.64-45L142.57 101 8.45 235.14a28.86 28.86 0 0 0 0 40.81l195.61 195.6a28.86 28.86 0 0 0 40.8 0l194.69-194.69a28.86 28.86 0 0 0 0-40.81z"/></svg>
  </div>
  <div class="md-source__repository">
    GitLab
  </div>
</a>
      </div>
    
  </nav>
  
    
      
<nav class="md-tabs" aria-label="Tabs" data-md-component="tabs">
  <div class="md-grid">
    <ul class="md-tabs__list">
      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../.." class="md-tabs__link">
          
  
  Home

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../../rtfm/" class="md-tabs__link">
          
  
  RTFM

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../../demo/" class="md-tabs__link">
          
  
  Demo

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../../setup/" class="md-tabs__link">
          
  
  Setup

        </a>
      </li>
    
  

      
        
  
  
    
  
  
    
    
      <li class="md-tabs__item md-tabs__item--active">
        <a href="../../" class="md-tabs__link">
          
  
  Usage

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../help/" class="md-tabs__link">
          
  
  Reference

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../../resources/faq/" class="md-tabs__link">
          
  
  Resources

        </a>
      </li>
    
  

      
    </ul>
  </div>
</nav>
    
  
</header>
    
    <div class="md-container" data-md-component="container">
      
      
        
      
      <main class="md-main" data-md-component="main">
        <div class="md-main__inner md-grid">
          
            
              
              <div class="md-sidebar md-sidebar--primary" data-md-component="sidebar" data-md-type="navigation" >
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    


  


  

<nav class="md-nav md-nav--primary md-nav--lifted md-nav--integrated" aria-label="Navigation" data-md-level="0">
  <label class="md-nav__title" for="__drawer">
    <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="autovnet" class="md-nav__button md-logo" aria-label="autovnet" data-md-component="logo">
      
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M12 8a3 3 0 0 0 3-3 3 3 0 0 0-3-3 3 3 0 0 0-3 3 3 3 0 0 0 3 3m0 3.54C9.64 9.35 6.5 8 3 8v11c3.5 0 6.64 1.35 9 3.54 2.36-2.19 5.5-3.54 9-3.54V8c-3.5 0-6.64 1.35-9 3.54Z"/></svg>

    </a>
    autovnet
  </label>
  
    <div class="md-nav__source">
      <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="Go to repository" class="md-source" data-md-component="source">
  <div class="md-source__icon md-icon">
    
    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Free 6.4.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) Copyright 2023 Fonticons, Inc.--><path d="M439.55 236.05 244 40.45a28.87 28.87 0 0 0-40.81 0l-40.66 40.63 51.52 51.52c27.06-9.14 52.68 16.77 43.39 43.68l49.66 49.66c34.23-11.8 61.18 31 35.47 56.69-26.49 26.49-70.21-2.87-56-37.34L240.22 199v121.85c25.3 12.54 22.26 41.85 9.08 55a34.34 34.34 0 0 1-48.55 0c-17.57-17.6-11.07-46.91 11.25-56v-123c-20.8-8.51-24.6-30.74-18.64-45L142.57 101 8.45 235.14a28.86 28.86 0 0 0 0 40.81l195.61 195.6a28.86 28.86 0 0 0 40.8 0l194.69-194.69a28.86 28.86 0 0 0 0-40.81z"/></svg>
  </div>
  <div class="md-source__repository">
    GitLab
  </div>
</a>
    </div>
  
  <ul class="md-nav__list" data-md-scrollfix>
    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_1" >
        
          
          <label class="md-nav__link" for="__nav_1" id="__nav_1_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Home
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_1_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_1">
            <span class="md-nav__icon md-icon"></span>
            Home
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../.." class="md-nav__link">
        
  
  <span class="md-ellipsis">
    autovnet
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_2" >
        
          
          <label class="md-nav__link" for="__nav_2" id="__nav_2_label" tabindex="">
            
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_2_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_2">
            <span class="md-nav__icon md-icon"></span>
            RTFM
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../rtfm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../rtfm/paradigm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Paradigm
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../rtfm/autovnet/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    autovnet
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../rtfm/goals/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Goals
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_3" >
        
          
          <label class="md-nav__link" for="__nav_3" id="__nav_3_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Demo
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_3_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_3">
            <span class="md-nav__icon md-icon"></span>
            Demo
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../demo/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Demo
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../demo/proxy/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Proxy
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../demo/callback/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Callback
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_4" >
        
          
          <label class="md-nav__link" for="__nav_4" id="__nav_4_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Setup
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_4_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_4">
            <span class="md-nav__icon md-icon"></span>
            Setup
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Quick Start
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/network/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Network Design
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/install/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Install
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/configure/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Configure
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/local/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Local Install
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
    
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--active md-nav__item--section md-nav__item--nested">
      
        
        
        
        <input class="md-nav__toggle md-toggle " type="checkbox" id="__nav_5" checked>
        
          
          <label class="md-nav__link" for="__nav_5" id="__nav_5_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Usage
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_5_label" aria-expanded="true">
          <label class="md-nav__title" for="__nav_5">
            <span class="md-nav__icon md-icon"></span>
            Usage
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Usage
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_2" >
        
          
          <label class="md-nav__link" for="__nav_5_2" id="__nav_5_2_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    RDN
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_2_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_2">
            <span class="md-nav__icon md-icon"></span>
            RDN
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rdn/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    RDN
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rdn/proxy/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Proxy
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rdn/listen/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Listen
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rdn/tun/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Tun
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rdn/dns/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    DNS
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_3" >
        
          
          <label class="md-nav__link" for="__nav_5_3" id="__nav_5_3_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_3_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_3">
            <span class="md-nav__icon md-icon"></span>
            RTFM
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rtfm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rtfm/apt/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    APT
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rtfm/pasta/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Pasta
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_4" >
        
          
          <label class="md-nav__link" for="__nav_5_4" id="__nav_5_4_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    Pwn
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_4_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_4">
            <span class="md-nav__icon md-icon"></span>
            Pwn
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    pwn
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/share/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    File Hosting
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/pwncat/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    pwncat
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/winrm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    evil-winrm
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/metasploit/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    metasploit
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/merlin/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    merlin
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/sliver/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    sliver
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../pwn/ligolo_ng/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    ligolo-ng
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
    
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--active md-nav__item--nested">
      
        
        
        
        <input class="md-nav__toggle md-toggle " type="checkbox" id="__nav_5_5" checked>
        
          
          <label class="md-nav__link" for="__nav_5_5" id="__nav_5_5_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    Collaboration
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_5_label" aria-expanded="true">
          <label class="md-nav__title" for="__nav_5_5">
            <span class="md-nav__icon md-icon"></span>
            Collaboration
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Collaboration
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../svc/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Services
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../fs/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Shared Directories
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../vnc/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Screen Sharing
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
    
  
  
    <li class="md-nav__item md-nav__item--active">
      
      <input class="md-nav__toggle md-toggle" type="checkbox" id="__toc">
      
      
        
      
      
        <label class="md-nav__link md-nav__link--active" for="__toc">
          
  
  <span class="md-ellipsis">
    Shared Notes
  </span>
  

          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <a href="./" class="md-nav__link md-nav__link--active">
        
  
  <span class="md-ellipsis">
    Shared Notes
  </span>
  

      </a>
      
        

<nav class="md-nav md-nav--secondary" aria-label="Table of contents">
  
  
  
    
  
  
    <label class="md-nav__title" for="__toc">
      <span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
    <ul class="md-nav__list" data-md-component="toc" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#intro" class="md-nav__link">
    Intro
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#hedgedoc" class="md-nav__link">
    HedgeDoc
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#folders" class="md-nav__link">
    Folders?
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#hedgedoc-export" class="md-nav__link">
    hedgedoc export
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#hedgedoc-mount" class="md-nav__link">
    hedgedoc mount
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#security" class="md-nav__link">
    Security
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#backups" class="md-nav__link">
    Backups
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#recommended-restore" class="md-nav__link">
    Recommended Restore
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#alternate-manual-restore" class="md-nav__link">
    Alternate / Manual Restore
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#warm-spare" class="md-nav__link">
    Warm Spare
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#move-hedgedoc-instance" class="md-nav__link">
    Move HedgeDoc Instance
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#initalize-hedgedoc-instance" class="md-nav__link">
    Initalize HedgeDoc Instance
  </a>
  
</li>
      
    </ul>
  
</nav>
      
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../msfdb/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    msfdb
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../gitea/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    gitea
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../focalboard/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    focalboard
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../drawio/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    drawio
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../cyberchef/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    cyberchef
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../matrix/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    matrix
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../nextcloud/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    nextcloud
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../owncast/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    owncast
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_6" >
        
          
          <label class="md-nav__link" for="__nav_5_6" id="__nav_5_6_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    Util
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_6_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_6">
            <span class="md-nav__icon md-icon"></span>
            Util
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../util/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    util
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../util/tmp/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    tmp
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_6" >
        
          
          <label class="md-nav__link" for="__nav_6" id="__nav_6_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Reference
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_6_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_6">
            <span class="md-nav__icon md-icon"></span>
            Reference
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../help/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    autovnet
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_7" >
        
          
          <label class="md-nav__link" for="__nav_7" id="__nav_7_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Resources
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_7_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_7">
            <span class="md-nav__icon md-icon"></span>
            Resources
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/faq/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    FAQ
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/troubleshooting/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Troubleshooting
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/changelog/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Changelog
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/wild/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    In The Wild
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/refs/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    References
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
  </ul>
</nav>
                  </div>
                </div>
              </div>
            
            
          
          
            <div class="md-content" data-md-component="content">
              <article class="md-content__inner md-typeset">
                
                  

  
  


<h1 id="shared-notes">Shared Notes<a class="headerlink" href="#shared-notes" title="Permanent link">&para;</a></h1>
<div class="toc">
<ul>
<li><a href="#shared-notes">Shared Notes</a><ul>
<li><a href="#intro">Intro</a></li>
<li><a href="#hedgedoc">HedgeDoc</a></li>
<li><a href="#folders">Folders?</a></li>
<li><a href="#hedgedoc-export">hedgedoc export</a></li>
<li><a href="#hedgedoc-mount">hedgedoc mount</a></li>
<li><a href="#security">Security</a></li>
<li><a href="#backups">Backups</a></li>
<li><a href="#recommended-restore">Recommended Restore</a></li>
<li><a href="#alternate-manual-restore">Alternate / Manual Restore</a></li>
<li><a href="#warm-spare">Warm Spare</a></li>
<li><a href="#move-hedgedoc-instance">Move HedgeDoc Instance</a></li>
<li><a href="#initalize-hedgedoc-instance">Initalize HedgeDoc Instance</a></li>
</ul>
</li>
</ul>
</div>
<h2 id="intro">Intro<a class="headerlink" href="#intro" title="Permanent link">&para;</a></h2>
<p>Real-time, collaborative note-taking / document editing is critical for success in many wargames.</p>
<p>These notes are not a replacement for long-lived documentation in source control (e.g. git), but in an ideal world, all known information
about a particular target network / system, any actions taken against it, and any details about payloads deployed or persistence left should be documented "live",
as the player is actively engaging with the system.</p>
<p>By keeping these notes in a shared place, there is a timeline of actions taken, other new players can learn from your approach,
and other experienced players will know exactly where you left off, how your persistence is configured, any known credentials, etc. to continue hacking while you're away.</p>
<p>Writing things down shared both your knowledge and your effort - if you don't write things down,
your teammates may very well have to re-learn and re-do anything you already did, possibly in conflicting ways (e.g. accidentally overwriting your persistence with theirs) :)</p>
<h2 id="hedgedoc"><a href="https://hedgedoc.org/">HedgeDoc</a><a class="headerlink" href="#hedgedoc" title="Permanent link">&para;</a></h2>
<p><a href="https://hedgedoc.org/">HedgeDoc</a> is basically Google Docs, but good, and self-hosted. (Techincally, it's very similar to <a href="https://etherpad.org/">etherpad</a>, if you are familar with that.)</p>
<p>It supports real-time collaborative editing (like Google Docs), but everything is Markdown, with live previews!</p>
<p>Because the document format is Markdown, it supports formated code blocks, and is easy to work with, copy, paste, export, and transfer (binary documents bad).</p>
<p>With <code>autovnet</code>, one player hosts the HedgeDoc server, and any interested players mount the service locally.</p>
<p>Because of how HedgeDoc uses internal urls, all players must mount the service on the same local port that matches the host's server configuration.</p>
<p>Since hacker notes are one of the most important collaboration features, <code>hedgedoc</code> gets the honor of defaulting to <code>127.0.0.1:1337</code>.</p>
<p>That is, when following the example below, all players will be able to go to <code>http://127.0.0.1:1337/home</code> in their browser access the shared HedgeDoc instance.</p>
<h2 id="folders">Folders?<a class="headerlink" href="#folders" title="Permanent link">&para;</a></h2>
<p>One potential suprise for new users is that (at least until HedgeDoc 2.X), there is really no concept of folders for saving notes (each "page" / "document" is called a note).</p>
<p>Each note has a unique URL and is totally independent.
If you create a new note, a random URL is generated, and it is super difficult for anyone (including future-you) to find that note again later.</p>
<p>So, to keep things manageable and discoverable in a large, multi-player environment, the recommended instructions (which are printed for you when you start the server):
* Uses a custom URL /home as the "landing page" for your instance
* Asks everyone to create new pages by create a dangling link to it, e.g. <code>[Blue Team 01 Notes](/blue_01)</code>, then clicking the link
    - HedgeDoc is configured to create any page that does not exist when you access it</p>
<p>This strategy gives every page a helpful URL, and ensures that every page can be reached by following links from <code>/home</code>.</p>
<p>So while the lack of real directory trees may be unituitive at first, use your <code>/home</code> page to document your logical document tree however you want, and you should be fine.</p>
<h2 id="hedgedoc-export"><code>hedgedoc export</code><a class="headerlink" href="#hedgedoc-export" title="Permanent link">&para;</a></h2>
<p>Player 1 hosts the HedgeDoc instance:
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>hedgedoc
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>hedgedoc<span class="w"> </span>crowded_hate
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>connect<span class="w"> </span>:<span class="w"> </span>firefox<span class="w"> </span><span class="m">127</span>.0.0.1:1337
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>mount<span class="w">   </span>:<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>hedgedoc<span class="w"> </span>mount<span class="w"> </span>-C<span class="w"> </span>crowded_hate<span class="w"> </span><span class="m">10</span>.241.153.70:36513
...
</code></pre></div></p>
<p>As the host, they receive a helpful block of recommended instructions, including example instructions they can send to other players.</p>
<p>Following the printed instructions are recommended, since they are intended to help you keep your notes organized.</p>
<p>The host (Player 1) can run the generated <code>connect</code> command to access the instance.
<div class="highlight"><pre><span></span><code>firefox<span class="w"> </span><span class="m">127</span>.0.0.1:1337
</code></pre></div></p>
<h2 id="hedgedoc-mount"><code>hedgedoc mount</code><a class="headerlink" href="#hedgedoc-mount" title="Permanent link">&para;</a></h2>
<p>Then, Player 2 runs the generated <code>mount</code> command to mount the service locally to their <code>127.0.0.1:1337</code></p>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>hedgedoc<span class="w"> </span>mount<span class="w"> </span>-C<span class="w"> </span>crowded_hate<span class="w"> </span><span class="m">10</span>.241.153.70:36513
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>svc<span class="w"> </span>mount<span class="w"> </span>crowded_hate
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>mounted<span class="w"> </span>locally:<span class="w"> </span>http://127.0.0.1:1337/home
</code></pre></div>
<p>Now Player 2 can also access the shared HedgeDoc server at <code>127.0.0.1:1337</code>.
The <code>mount</code> command above will open the <code>hedgedoc</code> server in Player 2's default browser.</p>
<h2 id="security">Security<a class="headerlink" href="#security" title="Permanent link">&para;</a></h2>
<p>Under the hood, <code>autovnet rtfm hedgedoc</code> uses <code>autovnet rtfm svc</code> to securely share the service.</p>
<p>That means that all data in encrypted in transit, and other players with the <code>rtfm.key</code> from the <code>autovnet</code> game config can access the HedgeDoc server.</p>
<p>So, it's the perfect place to keep your hacker notes as you hack :)</p>
<h2 id="backups">Backups<a class="headerlink" href="#backups" title="Permanent link">&para;</a></h2>
<p>To give you some peace of mind that your notes are safe, <code>autovnet</code> will, by default, take a periodic backup of your HedgeDoc instance.</p>
<p>See the help menu for all the options available to control (or disable) this behavior.</p>
<p>The process for restoring the backup is pretty straightforward (adapted from https://docs.hedgedoc.org/setup/docker/#restore)</p>
<p>This section is about "reverting" a hedgedoc instance to a previous, good state on the same node.</p>
<p>If you would like to restore to a different node or tolerate node failure, see <a href="#warm-spare">Warm Spare</a> and <a href="#move-hedgedoc-instance">Move HedgeDoc Instance</a>.</p>
<p><em>Note: database restore techniques will not affect uploaded files, which are saved in /opt/rtfm/hedgedoc/code_name/uploads`</em></p>
<h2 id="recommended-restore">Recommended Restore<a class="headerlink" href="#recommended-restore" title="Permanent link">&para;</a></h2>
<ol>
<li>
<p>Identify the backup you would like to restore</p>
<ul>
<li>By default, it will be stored in <code>/opt/rtfm/hedgedoc/code_name/backups/</code></li>
</ul>
</li>
<li>
<p>Stop your existing <code>hedgedoc</code> command, if it is still running.</p>
</li>
<li>
<p>Test your backup before you commit to it:
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>hedgedoc<span class="w"> </span><span class="nb">export</span><span class="w"> </span>-q<span class="w"> </span>--init-sql<span class="w"> </span>/opt/rtfm/hedgedoc/code_name/backups/pg_dump.XXXXX.sql.gz
</code></pre></div></p>
</li>
</ol>
<p>This will create a new instance / code_name for you to inspect locally.
No other players will be connected to it, because it uses a different codename / <code>autovnet</code> IP.</p>
<p>You'll need to copy the contents of <code>/opt/rtfm/hedgedoc/old_code_name/uploads</code> to <code>/opt/rtfm/hedgedoc/new_code_name/uploads</code> for uploaded files / images to render correctly.</p>
<ol>
<li>When satified, restart the primary <code>hedgedoc</code> instance and reset the database in place (this will permantently delete any data currently in the database)
<div class="highlight"><pre><span></span><code><span class="c1"># Note: Now we also pass code_name (the original code name of the old instance)</span>
$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>hedgedoc<span class="w"> </span><span class="nb">export</span><span class="w"> </span>-q<span class="w"> </span>--init-sql<span class="w"> </span>/opt/rtfm/hedgedoc/code_name/backups/pg_dump.XXXXX.sql.gz<span class="w"> </span>code_name
...
<span class="o">[</span>!<span class="o">]</span><span class="w"> </span>--init-sql<span class="w"> </span>provided<span class="w"> </span>but<span class="w"> </span>database<span class="w"> </span>may<span class="w"> </span>already<span class="w"> </span>exist!<span class="w"> </span>Import<span class="w"> </span>anyway?<span class="w"> </span><span class="o">[</span>y/N<span class="o">]</span>:<span class="w"> </span>y
</code></pre></div></li>
</ol>
<p>Because you used your existing codename, no players need to take any action (other than refreshing their browser).</p>
<p>Alternatively, you could give all players the new <code>mount</code> command from <code>2.</code> and ask them all to switch to the new instance.</p>
<h2 id="alternate-manual-restore">Alternate / Manual Restore<a class="headerlink" href="#alternate-manual-restore" title="Permanent link">&para;</a></h2>
<ol>
<li>
<p>Identify the backup you would like to restore</p>
<ul>
<li>By default, it will be stored in <code>/opt/rtfm/hedgedoc/code_name/backups/</code></li>
</ul>
</li>
<li>
<p>Ensure that your autovnet hedgedoc command is still running</p>
<ul>
<li>Note: you can restore your backup on any system, or on a clean hedgedoc instance with a different codename</li>
</ul>
</li>
<li>
<p>Find the container names for the hedgedoc app and database</p>
</li>
</ol>
<p><div class="highlight"><pre><span></span><code>$<span class="w"> </span>docker<span class="w"> </span>ps<span class="w"> </span><span class="p">|</span><span class="w"> </span>grep<span class="w"> </span>hedgedoc
0fd7be3c8060<span class="w">   </span>quay.io/hedgedoc/hedgedoc:1.9.2<span class="w">     </span><span class="s2">&quot;/usr/local/bin/dock…&quot;</span><span class="w">   </span><span class="m">2</span><span class="w"> </span>minutes<span class="w"> </span>ago<span class="w">   </span>Up<span class="w"> </span><span class="m">2</span><span class="w"> </span>minutes<span class="w"> </span><span class="o">(</span>healthy<span class="o">)</span><span class="w">   </span><span class="m">127</span>.0.0.1:1337-&gt;1337/tcp,<span class="w"> </span><span class="m">3000</span>/tcp<span class="w">   </span>hedgedoc_nostalgic_improvement_app_1
2ca39ff24736<span class="w">   </span>postgres:latest<span class="w">                     </span><span class="s2">&quot;docker-entrypoint.s…&quot;</span><span class="w">   </span><span class="m">2</span><span class="w"> </span>minutes<span class="w"> </span>ago<span class="w">   </span>Up<span class="w"> </span><span class="m">2</span><span class="w"> </span>minutes<span class="w">             </span><span class="m">5432</span>/tcp<span class="w">                             </span>hedgedoc_nostalgic_improvement_database_1
</code></pre></div>
    * Here, the app is <code>hedgedoc_nostalgic_improvement_app_1</code> and the database is <code>hedgedoc_nostalgic_improvement_database_1</code>
    * It should always match <code>hedgedoc_CODE_NAME_[app|database]_1</code></p>
<ol>
<li>Kill the app container</li>
</ol>
<div class="highlight"><pre><span></span><code><span class="c1"># Use your app container name:</span>
$<span class="w"> </span>docker<span class="w"> </span><span class="nb">kill</span><span class="w"> </span>hedgedoc_nostalgic_improvement_app_1
</code></pre></div>
<ol>
<li>Restore the database backup (will delete anything currently in this database)</li>
</ol>
<div class="highlight"><pre><span></span><code><span class="c1"># Use your database container name:</span>
gunzip<span class="w"> </span>-c<span class="w"> </span>&lt;<span class="w"> </span>pg_dump.sql.gz<span class="w"> </span><span class="p">|</span><span class="w"> </span>docker<span class="w"> </span><span class="nb">exec</span><span class="w"> </span>-i<span class="w"> </span>hedgedoc_nostalgic_improvement_database_1<span class="w"> </span>psql<span class="w"> </span>-U<span class="w"> </span>hedgedoc
</code></pre></div>
<ol>
<li>If restoring to a different code name or different system, copy the old <code>/opt/rtfm/hedgedoc/code_name/uploads</code> to the new <code>code_name</code></li>
</ol>
<h2 id="warm-spare">Warm Spare<a class="headerlink" href="#warm-spare" title="Permanent link">&para;</a></h2>
<p>If your notes are mission critical, you are senstive to downtime, or you need to tolerate node failures with minimal data loss,
you can leverage the <code>fs</code> command's <code>--mirror</code> option to keep a warm spare of your hedgedoc instance.</p>
<p>Simply <code>fs export</code> the whole <code>code_name</code> directory on the <code>hedgedoc</code> host, and <code>fs mount --mirror</code> it on one or more secondary nodes.</p>
<p>The host exports the <code>nostalgic_improvement</code> directory:
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>fs<span class="w"> </span><span class="nb">export</span><span class="w"> </span>/opt/rtfm/hedgedoc/nostalgic_improvement
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>fs<span class="w"> </span><span class="nb">export</span><span class="w"> </span>-C<span class="w"> </span>dull_finish
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>export:<span class="w"> </span>/opt/rtfm/hedgedoc/nostalgic_improvement
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>mount:<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>fs<span class="w"> </span>mount<span class="w"> </span>-C<span class="w"> </span>dull_finish<span class="w"> </span><span class="m">10</span>.234.30.41:56334
</code></pre></div></p>
<p>Secondary players mirror the whole directory
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>fs<span class="w"> </span>mount<span class="w"> </span>-C<span class="w"> </span>dull_finish<span class="w"> </span><span class="m">10</span>.234.30.41:56334<span class="w"> </span>--mirror
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>fs<span class="w"> </span>mount<span class="w"> </span>dull_finish
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>mountpoint:<span class="w"> </span>/opt/rtfm/fs/dull_finish/mnt
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>mirror<span class="w"> </span>every<span class="w"> </span>60s<span class="w"> </span>to<span class="w"> </span>/opt/rtfm/fs/dull_finish/mirror
</code></pre></div></p>
<p>This will back up all exported backup files from <code>backups/</code>, all user-uploaded files from <code>uploads/</code>, and the <code>postgres</code> database files from <code>data/</code>.</p>
<p>It's <em>possible</em> but not guaranteed that a warm replica could be started as-is without restoring the database.
That is, since the database files were copied, if you copy or move <code>/opt/rtfm/fs/dull_finish/mirror</code> to <code>/opt/rtfm/hedgedoc/nostalgic_improvement</code>
on a secondary node, you may be able to simply <code>autovnet rtfm hedgedoc nostalgic_improvement</code> to transparently replace a failed node.</p>
<p>However, <a href="https://www.postgresql.org/docs/current/backup-file.html">this is not guaranteed to work</a>
unless your old node still exists and you can <a href="#move-hedgedoc-instance">gracefully move your instance to another node</a>.</p>
<p>So if the database errors out or things are broken, just restore from one of the backups that were also replicated.</p>
<h2 id="move-hedgedoc-instance">Move HedgeDoc Instance<a class="headerlink" href="#move-hedgedoc-instance" title="Permanent link">&para;</a></h2>
<p>If you HedgeDoc instance is fine and your node still exists, you can gracefully move the whole instance to another node, with minimal downtime,
by basically doing the <a href="https://www.postgresql.org/docs/current/backup-file.html">postgres filesystem backup strategy</a>, but with autovnet.</p>
<p>This is useful if you underestimated your disk space needs and ran out, or if you need to take a node down for maintenance.</p>
<ol>
<li>On the host, <code>fs export</code> the <code>code_name</code> directory:</li>
</ol>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>fs<span class="w"> </span><span class="nb">export</span><span class="w"> </span>/opt/rtfm/hedgedoc/nostalgic_improvement
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>fs<span class="w"> </span><span class="nb">export</span><span class="w"> </span>-C<span class="w"> </span>dull_finish
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>export:<span class="w"> </span>/opt/rtfm/hedgedoc/nostalgic_improvement
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>mount:<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>fs<span class="w"> </span>mount<span class="w"> </span>-C<span class="w"> </span>dull_finish<span class="w"> </span><span class="m">10</span>.234.30.41:56334
</code></pre></div>
<ol>
<li>
<p>On the new node, <code>fs mount</code> + <code>--mirror</code>, wait for the confirmation, then exit (<code>CTRL+C</code>)
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>fs<span class="w"> </span>mount<span class="w"> </span>-C<span class="w"> </span>dull_finish<span class="w"> </span><span class="m">10</span>.234.30.41:56334<span class="w"> </span>--mirror
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>fs<span class="w"> </span>mount<span class="w"> </span>dull_finish
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>mountpoint:<span class="w"> </span>/opt/rtfm/fs/dull_finish/mnt
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>mirror<span class="w"> </span>every<span class="w"> </span>60s<span class="w"> </span>to<span class="w"> </span>/opt/rtfm/fs/dull_finish/mirror
<span class="o">[</span><span class="m">2021</span>-12-28T14:11:28<span class="o">]</span><span class="w"> </span>Successful<span class="w"> </span>mirror<span class="w"> </span>to<span class="w"> </span>/opt/rtfm/fs/dull_finish/mirror
^C
</code></pre></div></p>
</li>
<li>
<p>On the host, stop running the <code>rtfm hedgedoc</code> command, and wait for it to gracefully exit</p>
</li>
<li>
<p>On the new node, re-mount and <code>--mirror</code> with <code>--mirror-checksum</code> (see https://www.postgresql.org/docs/current/backup-file.html)</p>
<ul>
<li>After the success confirmation, <code>CTRL+C</code> again.
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>fs<span class="w"> </span>mount<span class="w"> </span>dull_finish<span class="w"> </span>--mirror<span class="w"> </span>--mirror-checksum
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>fs<span class="w"> </span>mount<span class="w"> </span>dull_finish
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>mountpoint:<span class="w"> </span>/opt/rtfm/fs/dull_finish/mnt
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>mirror<span class="w"> </span>every<span class="w"> </span>60s<span class="w"> </span>to<span class="w"> </span>/opt/rtfm/fs/dull_finish/mirror
<span class="o">[</span><span class="m">2021</span>-12-28T14:13:57<span class="o">]</span><span class="w"> </span>Successful<span class="w"> </span>mirror<span class="w"> </span>to<span class="w"> </span>/opt/rtfm/fs/dull_finish/mirror
^C
</code></pre></div></li>
</ul>
</li>
<li>
<p>On the new node, move the mirror directory to <code>/opt/rtfm/hedgedoc/CODE_NAME</code></p>
</li>
</ol>
<div class="highlight"><pre><span></span><code>mv<span class="w"> </span>/opt/rtfm/fs/dull_finish/mirror<span class="w"> </span>/opt/rtfm/hedgedoc/nostalgic_improvement
</code></pre></div>
<ol>
<li>Now the new node's <code>/opt/rtfm/hedgedoc/CODE_NAME</code> directory should be an exact copy of the old node's, so you can start the new instance on the new node as if it were native to that node.<ul>
<li>Because of the under-the-hood design, regular players don't need to make any changes or re-mount the service - the new instance will transparently replace the old one</li>
<li>If appropriate, update any <a href="#warm-spare">warm spare</a> nodes to start replicating the new instance
<div class="highlight"><pre><span></span><code><span class="c1"># On new node</span>
$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>hedgedoc<span class="w"> </span>-q<span class="w"> </span>nostalgic_improvement
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>hedgedoc<span class="w"> </span>nostalgic_improvement
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>connect<span class="w"> </span>:<span class="w"> </span>firefox<span class="w"> </span><span class="m">127</span>.0.0.1:1337
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>mount<span class="w">   </span>:<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>svc<span class="w"> </span>mount<span class="w"> </span>-C<span class="w"> </span>nostalgic_improvement<span class="w"> </span><span class="m">10</span>.213.134.254:39684<span class="w"> </span>-p<span class="w"> </span><span class="m">1337</span>
</code></pre></div></li>
</ul>
</li>
</ol>
<h2 id="initalize-hedgedoc-instance">Initalize HedgeDoc Instance<a class="headerlink" href="#initalize-hedgedoc-instance" title="Permanent link">&para;</a></h2>
<p>It might be helpful to import a previous HedgeDoc instance full of notes and helpful resources into a brand-new game environment.
* For example, maybe you have some standard pages for orientation and <a href="https://csrc.nist.gov/glossary/term/roe">ROE</a> that you re-use between games.</p>
<p>This is easy using the automatic backup feature described above.
<div class="highlight"><pre><span></span><code><span class="c1"># You can set --force-init-sql to avoid the confirmation prompt if you are scripting</span>
$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>hedgedoc<span class="w"> </span><span class="nb">export</span><span class="w"> </span>-q<span class="w"> </span>--init-sql<span class="w"> </span>pg_dump.XXXXX.sql.gz
</code></pre></div></p>
<p>If needed, you can populate <code>/opt/rtfm/hedgedoc/code_name/uploads</code> with any uploaded files / images from your previous instance.</p>





                
              </article>
            </div>
          
          
        </div>
        
          <button type="button" class="md-top md-icon" data-md-component="top" hidden>
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M13 20h-2V8l-5.5 5.5-1.42-1.42L12 4.16l7.92 7.92-1.42 1.42L13 8v12Z"/></svg>
  Back to top
</button>
        
      </main>
      
        <footer class="md-footer">
  
  <div class="md-footer-meta md-typeset">
    <div class="md-footer-meta__inner md-grid">
      <div class="md-copyright">
  
  
    Made with
    <a href="https://squidfunk.github.io/mkdocs-material/" target="_blank" rel="noopener">
      Material for MkDocs
    </a>
  
</div>
      
    </div>
  </div>
</footer>
      
    </div>
    <div class="md-dialog" data-md-component="dialog">
      <div class="md-dialog__inner md-typeset"></div>
    </div>
    
    
    <script id="__config" type="application/json">{"base": "../../..", "features": ["search.suggest", "search.highlight", "navigation.instant", "navigation.tracking", "navigation.tabs", "navigation.tabs.sticky", "navigation.top", "navigation.expand", "toc.integrate", "toc.follow", "navigation.top", "content.code.copy"], "search": "../../../assets/javascripts/workers/search.f886a092.min.js", "translations": {"clipboard.copied": "Copied to clipboard", "clipboard.copy": "Copy to clipboard", "search.result.more.one": "1 more on this page", "search.result.more.other": "# more on this page", "search.result.none": "No matching documents", "search.result.one": "1 matching document", "search.result.other": "# matching documents", "search.result.placeholder": "Type to start searching", "search.result.term.missing": "Missing", "select.version": "Select version"}}</script>
    
    
      <script src="../../../assets/javascripts/bundle.aecac24b.min.js"></script>
      
    
  </body>
</html>